<?php
// No direct access
defined( '_JEXEC' ) or die;

/**
 *
 * @package     Joomla.Plugin
 * @subpackage  System.Js_Kladr_Vmopc
 * @since       2.5+
 * @author		alekseygen
 */
class plgSystemJs_Kladr_Vmopc extends JPlugin{
	/**
	 * Class Constructor
	 * @param object $subject
	 * @param array $config
	 */
	public function __construct( & $subject, $config ){
		parent::__construct( $subject, $config );
		$this->loadLanguage();
	}

	public function onAfterInitialise(){  }

	public function onAfterRoute(){  }

	public function onAfterDispatch(){  }

	public function onBeforeRender(){  }

	function onAfterRender(){  }

	public function onBeforeCompileHead(){
		//print_r(JRequest::getVar("view"));
		//print_r(JRequest::getVar("option"));
		if (((JRequest::getVar("option") == "com_virtuemart" && JRequest::getVar("view") == "user" && (JRequest::getVar("task") == "editaddresscart" || JRequest::getVar("layout") == "edit")) || (JRequest::getVar("option") == "com_virtuemart" && JRequest::getVar("view") == "cart")) || (JRequest::getVar("option") == "com_virtuemart" && JRequest::getVar("view") == "user")) {		    
			$doc = JFactory::getDocument();
			
			$user = JFactory::getUser();
			$user_prov = "";
            if ($user->get('guest') == 1){
                $user_prov = "unlog";
            }else{
                $user_prov = "log";
            }			
            $doc->addStyleSheet(JURI::root(true) . "/plugins/system/js_kladr_vmopc/css/jquery.kladr.min.css");           
			$doc->addScript("https://api-maps.yandex.ru/2.0/?load=package.full&lang=ru-RU", $type = 'text/javascript');			
            $doc->addScript(JURI::root(true) . "/plugins/system/js_kladr_vmopc/js/kladr.js", $type = 'text/javascript');
			$doc->addScriptDeclaration('
			var block_map            = "'.$this->params->get("block_map", "").'",
			    block_adress         = "'.$this->params->get("block_adress", "").'",
				
				selector_block_js    = "'.$this->params->get("selector_block_js", "#onepage_main_div,  form#adminForm.form-validate").'",
				
				block_country        = "'.$this->params->get("virtuemart_country_id", "").'",
				block_zip            = "'.$this->params->get("zip", "").'",
				block_region         = "'.$this->params->get("virtuemart_state_id", "").'",
				block_distric        = "'.$this->params->get("district", "").'",
				block_city           = "'.$this->params->get("city", "").'",
				block_street         = "'.$this->params->get("address_1", "").'",
				block_address_2      = "'.$this->params->get("address_2", "").'",
				block_address_3      = "'.$this->params->get("address_3", "").'",
				
				user_prov       = "'.$user_prov.'";
				
				var token = "'.base64_decode($this->params->get("token", "51dfe5d42fb2b43e3300006e")).'";
				var key = "'.base64_decode($this->params->get("key", "86a2c2a06f1b2451a87d05512cc2c3edfdf41969")).'";	
							
		        var map = null,
				map_created = false;	
				
				var yam_region     = "",
				yam_region_val = "",
				select_val     = "";			
			
			jQuery( document ).ready(function($) {
	
				var container = jQuery(selector_block_js);
				
	            var $zip      = container.find("[name=\"" + block_zip + "\"]"),
	                $region   = container.find("[name=\"" + block_region + "\"]"),
		            $district = container.find("[name=\"" + block_distric + "\"]"),
		            $city     = container.find("[name=\"" + block_city + "\"]"),
		            $street   = container.find("[name=\"" + block_street + "\"]"),
		            $building = container.find("[name=\"" + block_address_2 + "\"]");					
					$room     = container.find("[name=\"" + block_address_3 + "\"]");	
				
					
				if(block_map.length){
					jQuery(block_map).prepend("<div id=\"map\" class=\"panel-map\" style=\"height: 300px;\"> </div>");					
				}	
				
				if(block_address_3.length){
				    $room.on("input",  function() {	
			        	addressUpdate();
	    			});
				}		
					
				$.kladr.setDefault({
				    token: token,        
		            key: key,
		            parentInput: selector_block_js,
		            verify: true,
		            labelFormat: function (obj, query) {
			        var label = "";

			        var name = obj.name.toLowerCase();
			        query = query.name.toLowerCase();

			        var start = name.indexOf(query);
			        start = start > 0 ? start : 0;

			        if (obj.typeShort) {
				        label += obj.typeShort + ". ";
			        }

			        if (query.length < obj.name.length) {
				        label += obj.name.substr(0, start);
				        label += "<strong>" + obj.name.substr(start, query.length) + "</strong>";
				        label += obj.name.substr(start + query.length, obj.name.length - query.length - start);
			        } else {
				        label += "<strong>" + obj.name + "</strong>";
			        }

			        if (obj.parents) {
				        for (var k = obj.parents.length - 1; k > -1; k--) {
					        var parent = obj.parents[k];
					        if (parent.name) {
						        if (label) label += "<small>, </small>";
						        label += "<small>" + parent.name + " " + parent.typeShort + ".</small>";
					        }
				        }
			        }

			        return label;
		        },
		        change: function (obj) {
			        if (obj) {
				        setLabel($(this), obj.type);
			        }

			        log(obj);
			        if(block_adress.length){
				        addressUpdate();
					}
				    if(block_map.length){
					    mapUpdate();
					}
			      
		        },
		        checkBefore: function () {
			        var $input = $(this);

			        if (!$.trim($input.val())) {
				        log(null);
						if(block_adress.length){
				            addressUpdate();
						}
				        if(block_map.length){
					        mapUpdate();
					    }
				        return false;
			        }
		        }
	            });
	            
		        if(user_prov == "unlog"){
				    ymaps.ready(function(){
                        var geolocation = ymaps.geolocation;    
                        if(!geolocation.city){
                            if($city.val() && $city.val() != " "){
                                geolocation.city = $city.val();
                            }else{
                                geolocation.city = "Москва";
                            }
// console.log(geolocation.city+ " !geolocation.city");                      
                            $city.kladr({
                                "type": $.kladr.type.city,
                                "verify": true
                            });
                       
                            $.kladr.api({
                                token : token,
                                key   : key,
                                type  : $.kladr.type.city,
                                name  : geolocation.city
                            }, function (obj){ 
                                $.kladr.setValues({  city: geolocation.city, street : $street.val(), building: $building.val() }, "form");
                       
                                $city.parents(".field_wrapper.input-wrap").addclass("labelup");
                                $zip.parents(".field_wrapper.input-wrap").addClass("labelup"); 	                                
                            });
                        }else{
                            $city.kladr({
                                type   : $.kladr.type.city,
                                verify : true
                            });
                            $.kladr.api({
                                token : token,
                                key   : key,
                                type  : $.kladr.type.city,
                                name  : geolocation.city
                            }, function (obj){
                                    if($city.val() && $city.val() != " "){
                                        geolocation.city = $city.val();
                                    }   
// console.log(geolocation.city + " else");  									
                                    $.kladr.setValues({city: geolocation.city, street: $street.val(),  building: $building.val() }, container);
									
                                    $city.parents(".field_wrapper.input-wrap").addClass("labelup");                                  
                                    $zip.parents(".field_wrapper.input-wrap").addClass("labelup");
                            });
                        }
                    });                        
    			}else {
		        	$city.kladr({
			            type   : $.kladr.type.city,
			            verify : true
			        })
			    
                    $.kladr.api({
                        token : token,
                        key   : key,
                        type  : $.kladr.type.city,
                        name  : $city.val()
                    }, function (obj) {
                     	//console.log(3, $city.val(), $street.val(), $building.val());
                        $.kladr.setValues({city : $city.val(), street : $street.val(), building : $building.val()}, container);
                          
                        $city.parents(".field_wrapper.input-wrap").addClass("labelup");
                        jQuery("select[name=\"" + block_region+ "\"] option:selected").parents(".field_wrapper.input-wrap").addClass("labelup");                    
                   	});
				}
				
	            $zip.kladr("type", $.kladr.type.zip);
	            $region.kladr("type", $.kladr.type.region);
	            $district.kladr("type", $.kladr.type.district);
	            $city.kladr("type", $.kladr.type.city);
	            $street.kladr("type", $.kladr.type.street);
	            $building.kladr("type", $.kladr.type.building);				

	            // Включаем получение родительских объектов для населённых пунктов
	            $city.kladr("withParents", true);
	            $street.kladr("withParents", true);
	            $building.kladr("widthParents", true);

	            // Отключаем проверку введённых данных для региона
	            $region.kladr("verify", false);
	
	            // Отключаем проверку введённых данных для строений
	            //$building.kladr("verify", false);				
				
	            // Подключаем плагин для почтового индекса
	            //$zip.kladrZip();

	            if(block_map.length){

				ymaps.ready(function () {
		            if (map_created) return;
		            map_created = true;
		            map = new ymaps.Map("map", {
			            center: [55.76, 37.64],
			            zoom: 10,
			            controls: []
		            });

		            map.controls.add("zoomControl", {
			            position: {
				        right: 10,
				        top: 10
			            }
		            });
		            map.controls.add("typeSelector").add("mapTools", { left: 35, top: 5 });

	            });
				}
			
	            function setLabel($input, text) {
				    //console.log(text.charAt(0).toLowerCase());
/*
		            text = text.charAt(0).toUpperCase() + text.substr(1).toLowerCase();					
					var input = $input.val();
		            $input.val(text+". "+input);
*/
/*
					text = text.charAt(0).toUpperCase() + text.substr(1).toLowerCase();
		            $input.parent().find("label").text(text);
*/
	            }
				function mapUpdate() {
		            var zoom = 4;
		            var address = $.kladr.getAddress(selector_block_js, function (objs) {
			        var result = "";		        

			        $.each(objs, function (i, obj) {
				        var name = "",
					    type = "";

				        if ($.type(obj) === "object") {
					        name = obj.name;
					        type = " " + obj.type;

					        switch (obj.contentType) {
						        case $.kladr.type.region:
							    zoom = 5;
//console.log($.kladr.type.region);								
							    break;

						    case $.kladr.type.district:
							    zoom = 7;
//console.log($.kladr.type.district);								
							    break;

						    case $.kladr.type.city:
							    zoom = 10;
//console.log($.kladr.type.city);							    
							    break;

						    case $.kladr.type.street:
							    zoom = 14;
//console.log($.kladr.type.street);								
							    break;

						    case $.kladr.type.building:
							    zoom = 16;
//console.log($.kladr.type.building);								
							    break;
					        }
				        }else {
					        name = obj;
				        }

				        if (result) result += ", ";
				        result += type + name;
		         	});
			        return result;
	        	    });

		            if (address && map_created) {
			            var geocode = ymaps.geocode(address);
			            geocode.then(function (res) {
				            map.geoObjects.each(function (geoObject) {
					            map.geoObjects.remove(geoObject);
				            });

				            var position = res.geoObjects.get(0).geometry.getCoordinates(),
					        placemark = new ymaps.Placemark(position, {}, {});

				            map.geoObjects.add(placemark);
				            map.setCenter(position, zoom);
			            });
		            }
	            }
				function addressUpdate() {				    
					if(address_virtuemart_country_id = jQuery("select[name=\"" + block_country + "\"] option:selected").text()){
					    address_virtuemart_country_id = address_virtuemart_country_id + ", ";
					}else{
					    address_virtuemart_country_id = "";
					}					
					
					if(address_zip = jQuery("input[name=\"" + block_zip + "\"]").val()){
					    address_zip = address_zip + ", ";
					}else{
					    address_zip = "";
					}					
					
					if(address_virtuemart_state_id = jQuery("select[name=\"" + block_region + "\"]  option:selected").text()){
					    address_virtuemart_state_id = address_virtuemart_state_id + ", ";
					}else{
					    address_virtuemart_state_id = "";
					}
										
					if(address_city = jQuery("input[name=\"" + block_city + "\"]").val()){
					    address_city = address_city + ", ";
					}else{
					    address_city = "";
					}
										
					if(address_address_1 = jQuery("input[name=\"" + block_street + "\"]").val()){
					    address_address_1 = address_address_1 + ", ";
					}else{
					    address_address_1 = "";
					}					
					
					if(address_address_2 = jQuery("input[name=\"" + block_address_2 + "\"]").val()){
					    address_address_2 = address_address_2 + ", ";
					}else{
					    address_address_2 = "";
					}					
					
					if(address_address_3 = jQuery("input[name=\"" + block_address_3 + "\"]").val()){
					    address_address_3 = address_address_3;
					}else{
					    address_address_3 = "";
					}
					
					if(block_adress.length){
					    var arr = block_adress.split(",");
					    arr.forEach(function(item, i, arr) {
					       //alert( i + ": " + item + " (массив:" + arr + ")" ); 
					       //alert(item);
					       	$(item).siblings(".after_block_adress").remove();
		                    $(item).after("<div class=\"after_block_adress\">" +address_virtuemart_country_id + address_zip + address_virtuemart_state_id + address_city + address_address_1 + address_address_2 +  address_address_3 +"</div>");
					     });
					}
	            }			
				
	            function log(obj) {
		            var $log, i, cityId;		             
		            for (i in obj) {

					    if(i == "zip"){				   
                            $zip.val(obj[i]);
						}
	                    
				        if(i == "id"){
					        cityId = obj[i];					
				        }				
				        if(obj[i] == "city"){	//ищем и устанавливаем регион	по КЛАДР населенного пункта					            	                    
		                    var apiQuery = {
					            token : token,
                                key : key,
						        contentType : "region", 
						        cityId : cityId,
						        limit : "1"						
                            };			
				            $.getJSON($.kladr.url + "?callback=?",apiQuery,function(data) {
                                $(".right_adress").text(JSON.stringify(data.result, null, 4));
						        for (var i =0; i< data.result.length ;i++) { 							
							        yam_region = data.result[i].name;
							        if(data.result[i].name.length > 2){//подставляем значение региона в список регионов select virtuemart
									
								        select_val = $("select[name=\"" + block_region + "\"] option:contains("+yam_region+")").val();//для компонента OPC
										if(typeof select_val != "undefined"){                                      
                                        
										    var chzn_results = $("ul.chzn-results li:contains("+yam_region+")").text();  // для virtuemart пр правке данных личного кабинета
										
										   if(chzn_results.length){
										        $("ul.chzn-results li").removeClass( "result-selected" );
										    	$("ul.chzn-results li:contains("+chzn_results+")").addClass( "result-selected" );
									    		$("#virtuemart_state_id_field_chzn.chzn-container.chzn-container-single a.chzn-single span").text(chzn_results);
									    	}
								            if(select_val.length){										    
									            $("select[name=\"" + block_region + "\"] option:selected").each(function(){
                                                    this.selected=false;
	                                           });
										    	$("select[name=\"" + block_region + "\"]").find("option").removeAttr("selected");											
								                $("select[name=\"" + block_region + "\"] option[value=\""+select_val+"\"]").attr("selected", "selected").parents(".field_wrapper.input-wrap").addClass("labelup");											
										    	if(block_adress.length){
				                                    addressUpdate();
						                        }
								            }
										}else{
                                            //console.log(select_val);
										}
								        //console.log(select_val);
							        }
						        }					
					        });
				        }		
		            }
	            }				
			});
            ', $type = 'text/javascript');				
		}
	}
}
